#include "php_gtk.h"
#if HAVE_PHP_GTK

#include "gtkspaned.h"
#include "gtkshpaned.h"
#include "gtksvpaned.h"
#include "ext/gtk+/php_gtk+.h"

void php_spaned_register_constants(int module_number TSRMLS_DC)
{


}

PHP_GTK_EXPORT_CE(gtk_spaned_ce);
PHP_GTK_EXPORT_CE(gtk_shpaned_ce);
PHP_GTK_EXPORT_CE(gtk_svpaned_ce);

/* object GtkSPaned  */

PHP_FUNCTION(gtk_spaned_get_type)
{
	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	RETURN_LONG(gtk_spaned_get_type());
}


PHP_FUNCTION(gtk_spaned_add1)
{
	zval *child;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "O", &child, gtk_widget_ce))
		return;

	gtk_spaned_add1(GTK_SPANED(PHP_GTK_GET(this_ptr)), GTK_WIDGET(PHP_GTK_GET(child)));
	RETURN_NULL();
}


PHP_FUNCTION(gtk_spaned_add2)
{
	zval *child;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "O", &child, gtk_widget_ce))
		return;

	gtk_spaned_add2(GTK_SPANED(PHP_GTK_GET(this_ptr)), GTK_WIDGET(PHP_GTK_GET(child)));
	RETURN_NULL();
}


PHP_FUNCTION(gtk_spaned_pack1)
{
	zval *child;
	zend_bool resize = TRUE, shrink = TRUE;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "O|bb", &child, gtk_widget_ce, &resize, &shrink))
		return;

	gtk_spaned_pack1(GTK_SPANED(PHP_GTK_GET(this_ptr)), GTK_WIDGET(PHP_GTK_GET(child)), (gboolean)resize, (gboolean)shrink);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_spaned_pack2)
{
	zval *child;
	zend_bool resize = TRUE, shrink = TRUE;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "O|bb", &child, gtk_widget_ce, &resize, &shrink))
		return;

	gtk_spaned_pack2(GTK_SPANED(PHP_GTK_GET(this_ptr)), GTK_WIDGET(PHP_GTK_GET(child)), (gboolean)resize, (gboolean)shrink);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_spaned_set_position)
{
	long position;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "i", &position))
		return;

	gtk_spaned_set_position(GTK_SPANED(PHP_GTK_GET(this_ptr)), (gint)position);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_spaned_set_handle_size)
{
	long size;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "i", &size))
		return;

	gtk_spaned_set_handle_size(GTK_SPANED(PHP_GTK_GET(this_ptr)), (guint16)size);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_spaned_set_fixed)
{
	zend_bool fixed;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "b", &fixed))
		return;

	gtk_spaned_set_fixed(GTK_SPANED(PHP_GTK_GET(this_ptr)), (gboolean)fixed);
	RETURN_NULL();
}


PHP_FUNCTION(gtk_spaned_compute_position)
{
	long allocation, child1_req, child2_req;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "iii", &allocation, &child1_req, &child2_req))
		return;

	gtk_spaned_compute_position(GTK_SPANED(PHP_GTK_GET(this_ptr)), (gint)allocation, (gint)child1_req, (gint)child2_req);
	RETURN_NULL();
}


static function_entry php_gtk_spaned_functions[] = {
	{"GtkSPaned",	PHP_FN(no_constructor),	NULL},
	{"gtkspaned",	PHP_FN(no_constructor),	NULL},
	{"get_type",	PHP_FN(gtk_spaned_get_type),	NULL},
	{"add1",	PHP_FN(gtk_spaned_add1),	NULL},
	{"add2",	PHP_FN(gtk_spaned_add2),	NULL},
	{"pack1",	PHP_FN(gtk_spaned_pack1),	NULL},
	{"pack2",	PHP_FN(gtk_spaned_pack2),	NULL},
	{"set_position",	PHP_FN(gtk_spaned_set_position),	NULL},
	{"set_handle_size",	PHP_FN(gtk_spaned_set_handle_size),	NULL},
	{"set_fixed",	PHP_FN(gtk_spaned_set_fixed),	NULL},
	{"compute_position",	PHP_FN(gtk_spaned_compute_position),	NULL},
	{NULL, NULL, NULL}
};


/* object GtkSHPaned  */

PHP_FUNCTION(gtk_shpaned_new)
{
	GtkObject *wrapped_obj;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "")) {
		php_gtk_invalidate(this_ptr);
		return;
	}

	wrapped_obj = (GtkObject *)gtk_shpaned_new();
	if (!wrapped_obj) {
		php_error(E_WARNING, "%s(): could not create GtkSHPaned object",
				  get_active_function_name(TSRMLS_C));
		php_gtk_invalidate(this_ptr);
		return;
	}

	php_gtk_object_init(wrapped_obj, this_ptr);

}


PHP_FUNCTION(gtk_shpaned_get_type)
{
	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	RETURN_LONG(gtk_shpaned_get_type());
}


static function_entry php_gtk_shpaned_functions[] = {
	{"GtkSHPaned",	PHP_FN(gtk_shpaned_new),	NULL},
	{"gtkshpaned",	PHP_FN(gtk_shpaned_new),	NULL},
	{"get_type",	PHP_FN(gtk_shpaned_get_type),	NULL},
	{NULL, NULL, NULL}
};


/* object GtkSVPaned  */

PHP_FUNCTION(gtk_svpaned_new)
{
	GtkObject *wrapped_obj;

	NOT_STATIC_METHOD();

	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), "")) {
		php_gtk_invalidate(this_ptr);
		return;
	}

	wrapped_obj = (GtkObject *)gtk_svpaned_new();
	if (!wrapped_obj) {
		php_error(E_WARNING, "%s(): could not create GtkSVPaned object",
				  get_active_function_name(TSRMLS_C));
		php_gtk_invalidate(this_ptr);
		return;
	}

	php_gtk_object_init(wrapped_obj, this_ptr);

}


PHP_FUNCTION(gtk_svpaned_get_type)
{
	if (!php_gtk_parse_args(ZEND_NUM_ARGS(), ""))
		return;

	RETURN_LONG(gtk_svpaned_get_type());
}


static function_entry php_gtk_svpaned_functions[] = {
	{"GtkSVPaned",	PHP_FN(gtk_svpaned_new),	NULL},
	{"gtksvpaned",	PHP_FN(gtk_svpaned_new),	NULL},
	{"get_type",	PHP_FN(gtk_svpaned_get_type),	NULL},
	{NULL, NULL, NULL}
};


void php_spaned_register_classes(void)
{
	zend_class_entry ce;
	TSRMLS_FETCH();

	INIT_OVERLOADED_CLASS_ENTRY(ce, "GtkSPaned", php_gtk_spaned_functions, NULL, NULL, php_gtk_set_property);
	gtk_spaned_ce = zend_register_internal_class_ex(&ce, gtk_container_ce, NULL TSRMLS_CC);
	g_hash_table_insert(php_gtk_class_hash, g_strdup("GtkSPaned"), gtk_spaned_ce);

	INIT_OVERLOADED_CLASS_ENTRY(ce, "GtkSHPaned", php_gtk_shpaned_functions, NULL, NULL, php_gtk_set_property);
	gtk_shpaned_ce = zend_register_internal_class_ex(&ce, gtk_spaned_ce, NULL TSRMLS_CC);
	g_hash_table_insert(php_gtk_class_hash, g_strdup("GtkSHPaned"), gtk_shpaned_ce);

	INIT_OVERLOADED_CLASS_ENTRY(ce, "GtkSVPaned", php_gtk_svpaned_functions, NULL, NULL, php_gtk_set_property);
	gtk_svpaned_ce = zend_register_internal_class_ex(&ce, gtk_spaned_ce, NULL TSRMLS_CC);
	g_hash_table_insert(php_gtk_class_hash, g_strdup("GtkSVPaned"), gtk_svpaned_ce);


}

#endif /* HAVE_PHP_GTK */
